<?php
namespace nur\sery\schema\values;

use nur\sery\schema\Schema;

trait TValue {
  /** @var array schéma normalisé de cette valeur */
  protected array $schema;

  /** @var Schema */
  protected Schema $md;

  function md(): Schema {
    return Schema::new($this->md, $this->schema, true);
  }

  /** @var mixed valeur ou référence d'un tableau contenant la valeur */
  protected $value;

  /** @var string|int clé de la valeur dans le tableau destination */
  protected $key;

  function reset(&$value, $key=null, bool $verifix=true): void {
    $this->value =& $value;
    $this->key = $key;
    $this->result = null;
    if ($verifix) $this->verifix();
  }
}
